%define osmo	Osmo4
%define cvs	20061208
#%define mozver $(rpm -q --qf=%{VERSION} firefox-devel.%{_target_cpu})

Name: 	 	gpac
Summary: 	MPEG-4 multimedia framework
Version: 	0.4.3
Release: 	cvs%cvs.1%{?dist}
License:	LGPL
Group:		System Environment/Libraries
URL:		http://gpac.sourceforge.net/
Source0:	http://kwizart.free.fr/fedora/SOURCES/%{name}-%{cvs}.tar.bz2
Source4:	http://www.3gpp.org/ftp/Specs/archive/26_series/26.073/26073-600.zip
Source5:	http://www.3gpp.org/ftp/Specs/latest/Rel-6/26_series/26104-610.zip
Source6:	http://www.3gpp.org/ftp/Specs/latest/Rel-6/26_series/26204-600.zip
Source10:	%name-snapshot.sh
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -u -n)

BuildRequires:	ImageMagick
BuildRequires:	SDL-devel
BuildRequires:	librsvg2-devel >= 2.5.0
BuildRequires:	mesa-libGLU-devel
BuildRequires:	freetype-devel
BuildRequires:	faad2-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libmad-devel
BuildRequires:	xvidcore-devel >= 1.0.0
BuildRequires:  ffmpeg-devel
BuildRequires:	libxml2-devel
BuildRequires:	openssl-devel
BuildRequires:	zlib-devel
BuildRequires:	libogg-devel libvorbis-devel libtheora-devel
BuildRequires:	wxGTK-devel
BuildRequires:	js-devel
#BuildRequires:	firefox-devel
BuildRequires: /usr/bin/doxygen
#BuildRequires:	/usr/bin/strip
BuildRequires: 	desktop-file-utils

Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig


%description
GPAC is a multimedia framework based on the MPEG-4 Systems standard developed
from scratch in ANSI C.  The original development goal is to provide a clean
(a.k.a. readable by as many people as possible), small and flexible
alternative to the MPEG-4 Systems reference software.

The natural evolution has been the integration of recent multimedia standards
(SVG/SMIL, VRML, X3D, SWF, 3GPP(2) tools, etc) into a single framework.
VRML97 and a good amount of the X3D standard have already been integrated
into GPAC, as well as some SVG support and experimental Macromedia Flash
support.

The current GPAC release (0.4.0) already covers a very large part of the
MPEG-4 standard, and has some good support for 3GPP and VRML/X3D, and
features what can probably be seen as the most advanced and robust 2D MPEG-4
Player available worldwide, as well as a decent 3D player.

GPAC also features MPEG-4 Systems encoders/multiplexers, publishing tools for
content distribution for MP4 and 3GPP(2) files and many tools for scene
descriptions (MPEG4<->VRML<->X3D converters, SWF->MPEG-4, etc...).

%package	devel
Summary:	Dynamic development library for gpac
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description	devel
Dynamic development library for gpac.

%package -n	%osmo
Summary:	Media player based on gpac
Group:		Applications/Multimedia

%description -n %osmo
Osmo4 is an MPEG-4 player with the following features:
* MPEG-4 Systems player:
* Optimized 2D graphics renderer compliant with the Complete2D Scene Graph
	and Graphics profiles.
* Video and audio presentation achieved through plugins
* Multimedia player features:
	* Timeline controls: play, pause, step.
	* Graphics features: antialising, zoom and pan, scalable resizing of
		rendering area, basic full screen support.
	* Support for Advanced Text and Graphics extension of MPEG-4 Systems
		under standardization.
	* Frame export to JPG, PNG, BMP.

Osmo4 enables the use of MPEG-4 Systems in a vast aplication domain, among
which:
	* downloaded or streamed cartoons
	* synchronized, interactive mixes of graphics, text, video and audio
	* applications benefiting from MPEG-7 and MPEG-21 advances: 
		meta-data, encryption, watermarking, rights management


#%package -n firefox-%osmo
#Summary:	Osmo Media Player plugin for Mozilla compatible web browsers
#Group:		Applications/Multimedia	
#Requires:	%{osmo} = %{version}-%{release}
#Requires:	firefox >= 1.5.0.8


#%description -n firefox-%osmo
#This package contains a OSMO Media Player plugin for Mozilla compatible
#web browsers.
#It requires firefox %{mozver}

%prep
%setup -q -n %name-%cvs

## kwizart - use Osmo4 as a 3gpp player.
## from http://www.3gpp.org/
## License is unclear, possible LGPL.
%setup -q -D -T -a 4 -n %name-%cvs
unzip -qq -j -n -u 26073-600_ANSI_C_source_code.zip -d modules/amr_dec/amr_nb
%setup -q -D -T -a 5 -n %name-%cvs
unzip -qq 26104-610_ANSI_C_source_code.zip -d modules/amr_float_dec/amr_nb_ft/
install -m 0644 modules/amr_float_dec/amr_nb_ft/c-code/* modules/amr_float_dec/amr_nb_ft/
rm -rf modules/amr_float_dec/amr_nb_ft/c-code/
%setup -q -D -T -a 6 -n %name-%cvs
unzip -qq 26204-600_ANSI-C_source_code.zip -d modules/amr_float_dec/amr_wb_ft/
install -m 0644 modules/amr_float_dec/amr_wb_ft/c-code/* modules/amr_float_dec/amr_wb_ft/
rm -rf modules/amr_float_dec/amr_wb_ft/c-code/


## kwizart - GECKO_PATH is %{_includedir}/firefox-%{mozver} on fc6 (if not uses internal)
#%define mozver 1.5.0.8
#sed -i -e 's|GECKO_PATH=|GECKO_PATH=%{_includedir}/firefox-%{mozver}\n#GECKO_PATH=|' #applications/osmozilla/Makefile
#sed -i -e 's|-I$(GECKO_PATH)/plugin/include|-I$(GECKO_PATH)/plugin|' applications/#osmozilla/Makefile
#sed -i -e 's|-I$(GECKO_PATH)/nspr/include|-I$(GECKO_PATH)/nspr|' applications/osmozilla/#Makefile
#sed -i -e 's|-I$(GECKO_PATH)/java/include|-I$(GECKO_PATH)/java|' applications/osmozilla/#Makefile
#sed -i -e 's|-I$(GECKO_PATH)/xpcom/include|-I$(GECKO_PATH)/xpcom|' applications/osmozilla/#Makefile

## kwizart - disable osmozilla
rm -rf applications/osmozilla
sed -i -e 's|osmozilla||' applications/Makefile

## kwizart - enable dynamic mode - (SONAME problem ?)
%define soname libgpac.so.%{version}
#sed -i -e 's|#LDFLAGS="$LDFLAGS -rdynamic"|LDFLAGS="$LDFLAGS -rdynamic -Wl,-soname,${SONAME}"|' Makefile
sed -i -e 's|EXTRALIBS+=$(GPAC_SH_FLAGS)|EXTRALIBS+=$(GPAC_SH_FLAGS)\nLDFLAGS+="-Wl,-soname,%{soname}"|' src/Makefile
#sed -i -e 's/ldconfig || true//' Makefile


## lib64 compatible - original but wrong path
#perl -p -i -e 's/lGLU/lGLU\ \-L\/usr\/X11R6\/%{_lib}/g' configure
#perl -p -i -e 's,\$prefix/lib/gpac,\$prefix/%{_lib}/gpac,' configure
#perl -p -i -e 's,\$\(prefix\)/lib,\$(prefix)/%{_lib},' Makefile
## kwizart - lib64 compatible - modified 
sed -i -e 's|lGLU|lGLU -L%{_libdir}|g' configure
sed -i -e 's|$(prefix)/lib/gpac|%{_libdir}/gpac|' configure
sed -i -e 's|$(prefix)/lib|%{_libdir}|' Makefile
sed -i -e 's|$(prefix)/include|%{_includedir}|' Makefile
sed -i -e 's|$(prefix)/lib/$(LIB)|%{_libdir}/$(LIB)|' Makefile
%ifarch x86_64 ia64 ppc64
sed -i -e 's|is_64="no"|is_64="yes"|' configure
%endif


## kwizart - make install fails only with theses two
sed -i -e 's|"$(prefix)/bin"|"$(RPM_BUILD_ROOT)$(prefix)/bin"|' applications/mp4client/Makefile
sed -i -e 's|"$(prefix)/bin"|"$(RPM_BUILD_ROOT)$(prefix)/bin"|' applications/osmo4_wx/Makefile

## SHH! (kwizart - !? - this seems to produce less warnings!)
perl -p -i -e 's/Wall/w/g' `find -name Makefile`

## kwizart - if not chmod(ed), configure fails.
chmod 755 configure


%build
%configure \
	--enable-oss-audio						\
	--X11-path=%{_libdir}						\
	%{!?_with_amr:--enable-amr}

# kwizart - searching for X11 shared memory support here: ?!?
# 	--enable-sdl-static						\
#	--track-memory  						\
#	%{!?_with_mozdir:--mozdir=%{_libdir}/firefox-%{mozver}}		\
#	--X11_LIB_PATH=%{_libdir}					\
#	--X11_INC_PATH=%{_includedir}					\
#	--extra-ldflags="-rdynamic -Wl,-soname,%{soname}"		\
#	--extra-ldflags="-Wl,-soname,%{soname}"				\
#	%{!?_with_gprof:--enable-gprof}					\

## kwizart - some tweak are needed with config.mak result from configure.
## kwizart - Define cvs version in place of DEV - used in SONAME
sed -i -e 's|VERSION=%{version}-DEV|VERSION=%{version}-DEV-%{cvs}|' config.mak
## kwizart - Use config.mak because mozver sometimes fails.
#echo "GECKO_PATH=%{_includedir}/firefox-%{mozver}" >> config.mak
sed -i -e 's|DESTDIR=|DESTDIR=$(RPM_BUILD_ROOT)|' config.mak
sed -i -e 's|moddir=/usr/lib/gpac|moddir=%{_libdir}/gpac|' config.mak
sed -i -e 's|X11_LIB_PATH=/usr/lib64/lib64|X11_LIB_PATH=%{_libdir}|' config.mak
sed -i -e 's|X11_LIB_PATH=/usr/lib/lib|X11_LIB_PATH=%{_libdir}|' config.mak
sed -i -e 's|X11_INC_PATH=%{_libdir}/include|X11_INC_PATH=%{_includedir}|' config.mak


##
## Osmo-zila plugin.
##

#
# Rebuild osmozilla.xpt
#pushd applications/osmozilla
#%{_libdir}/firefox-%{mozver}/xpidl -m header  -I%{_datadir}/idl/firefox-%{mozver} #nsIOsmozilla.idl
#%{_libdir}/firefox-%{mozver}/xpidl -m typelib -I%{_datadir}/idl/firefox-%{mozver}/ #nsIOsmozilla.idl
#%{_libdir}/firefox-%{mozver}/xpt_link nposmozilla.xpt nsIOsmozilla.xpt
#mv nsIOsmozilla.xpt nsIOsmozilla.xpt_linux
#popd 

## kwizart - osmozilla parallel make fails
# %{?_smp_mflags}
#make -C applications/osmozilla 	\
#	OPTFLAGS="%optflags -fPIC -I%{_includedir}/nspr4/" 		\
#	INCLUDES="-I%{_datadir}/idl/firefox-%{mozver}/ 			\
#		-I%{_includedir}/firefox-%{mozver}/ 			\
#		-I%{_includedir}/firefox-%{mozver}/xpcom		\
#		-I%{_includedir}/nspr4/ $INCLUDES" 			\
#	XPIDL_INCL="-I%{_datadir}/idl/firefox-%{mozver}/ 		\
#		-I%{_includedir}/firefox-%{mozver}/ 			\
#		-I%{_includedir}/firefox-%{mozver}/xpcom		\
#		-I%{_includedir}/nspr4/ $INCLUDES" 			\
#install
##

## kwizart - gpac parallel make fails
# %{?_smp_mflags} 
make all
make sggen

## kwizart - build doxygen doc for devel
pushd doc
/usr/bin/doxygen
popd

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install install-lib

## kwizart - Install osmozilla plugin - make instmoz disabled.
# mkdir -p $RPM_BUILD_ROOT%{_libdir}/firefox-%{mozver}/plugins/
#install -m 755 bin/gcc/$(LIB) $RPM_BUILD_ROOT/mozilla/components/
# osmozilla.o npp_gate.o np_entry.o npn_gate.o
#/usr/bin/strip $RPM_BUILD_ROOT%{_libdir}/gpac/*.so
#/usr/bin/strip bin/gcc/nposmozilla.so
#install -m 755 bin/gcc/nposmozilla.so $RPM_BUILD_ROOT%{_libdir}/firefox-%{mozver}/plugins/#nposmozilla.so
#install -m 755 bin/gcc/nposmozilla.xpt $RPM_BUILD_ROOT%{_libdir}/firefox-%{mozver}/plugins/nposmozilla.xpt


# Desktop menu Osmo4
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cat > %{osmo}.desktop <<EOF
[Desktop Entry]
Name=Osmo4 Media Player
GenericName=Media Player
Comment=MPEG-4 Media Player
Exec=%{osmo}
Terminal=false
Icon=%{osmo}.xpm
Type=Application
Encoding=UTF-8
Categories=Application;AudioVideo;Player;
Version=%{version}-%{release}
EOF

desktop-file-install --vendor livna			\
	--dir $RPM_BUILD_ROOT%{_datadir}/applications	\
	--mode 644					\
	--add-category X-Livna				\
	%{osmo}.desktop

#icons
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -m 0644 applications/osmo4_wx/osmo4.xpm $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{osmo}.xpm

## kwizart - rpmlint gpac no-ldconfig-symlink
ln -sf  libgpac-%{version}-DEV-%{cvs}.so $RPM_BUILD_ROOT%{_libdir}/%{soname} 


%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig


%files
%defattr(-,root,root)
%doc AUTHORS BUGS Changelog COPYING README TODO 26073-600.doc 26104-610.doc 26204-600.doc
%{_bindir}/MP4*
%{_libdir}/libgpac-%{version}-DEV-%{cvs}.so
%{_libdir}/%{soname}
%{_libdir}/gpac
%{_mandir}/man1/*.1.gz
%{_datadir}/gpac/*


%files -n %osmo
%doc AUTHORS BUGS Changelog COPYING README TODO
%defattr(-,root,root)
%{_bindir}/Osmo4
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/%osmo.xpm

#%files -n firefox-%osmo
#%defattr(-,root,root)
#%{_libdir}/firefox-%{mozver}/plugins/nposmozilla.so
#%{_libdir}/firefox-%{mozver}/plugins/nposmozilla.xpt

%files 	devel
%doc doc/CODING_STYLE doc/ipmpx_syntax.bt
%doc doc/html/*
%defattr(-,root,root)
%{_includedir}/gpac
%{_libdir}/libgpac_static.a
%{_libdir}/libgpac.so


%changelog
* Thu Dec 08 2006 kwizart < kwizart at gmail.com > - 0.4.3-cvs20061208.1.kwizart.fc6
- Update to 20061208
- Uses firefox-devel (since fc6!)
- Drop tutorial
- Use version-DEV-date with libgpac.so
- Disabled osmozilla
- Fix soname 

* Tue Oct 17 2006 kwizart < kwizart at gmail.com > - 0.4.3-cvs20061017.1_FC5
- gpac snapshot.sh
- Revert Patch osmozilla.cpp (v1.17 - build error from gpac/internal/terminal_dev.h)
- TODO: - no-soname make option for libgpac.so
	- static lib in devel - needed ?
	- osmozilla - xpt link problem.
	- Osmo4: segmentation fault on exit.
	- MP4Client: segmentation fault on launch.
	- The program 'Osmo4' received an X Window System error:
	"The error was 'BadMatch (invalid parameter attributes)'.
	(Details: serial 37 error_code 8 request_code 42 minor_code 0)"
	- MP4Box -version display: GPAC version 0.4.3-DEV (try to display cvs )

* Sat Oct 15 2006 kwizart < kwizart at gmail.com > - 0.4.2-rc2.1_FC5
- Update to 0.4.2cvs20061017
- Use DESTDIR=RPM_BUILD_ROOT in various Makefile.
- Enable mozilla plugin: osmozilla.
- Enable AMR_NB_FLOAT and AMR_WB_FLOAT / bundle AMR_NB_FIXED (but not used by default).
- Provide documentation html in doc .
- Provide tutorial from http://www.wildamerica.com/pages/Marty.html
- Various corrections.

* Fri Sep 01 2006 Anssi Hannula <anssi@zarb.org> 0.4.1-0.20060630.2plf2007.0
- lib64 fixes

* Fri Jan 30 2006 Austin Acton <austin@mandriva.org> 0.4.1-0.20060630.1plf2007.0
- initial package
